Subject: Re: bug#16197: 24.3.50; no completion on commands following "sudo" in shell and eshell

From: Stefan Monnier <[email-masked]>
Date: Fri, 25 Sep 2020 13:51:05 -0400

> emacs -Q
> M-x shell
> $ find . -name '*.el' | xargs et!
> Press TAB, nothing, no completion against "et".

The patch below seems to address this problem for me.
Now I can do

    M-x shell
    % xargs cv TAB

and I get a list is commands starting with "cv"; and

    % xargs cvs TAB

lists `cvs`s subcommands.

> M-: (shell-backward-command)
> I have now the cursor at xargs:

That seems right to me.  I think changing it the way you describe could
lead to more problems down the line for cases where
`shell-backward-command` is used for other purposes.

> $ find . -name '*.el' | !xargs et
> To provide completion against "et" I should have the cursor at:
> $ find . -name '*.el' | xargs !et
> after evaling (shell-backward-command).

The beginning of the command is definitely "xargs" and not "et".
The fact that the first arg to the command is itself a command shouldn't
change where is the beginning of the command here, I think.

> For `pcomplete-command-name' it is harder to give a recipe, the best is
> to edebug it to have an idea (be careful the actual version is crashing
> emacs sometimes).

Same here, I'd think that the "command name" is "xargs", but rather than
argue about this philosophical point, it's probably better to focus on
more concrete cases where this return value is a problem.

        Stefan

diff --git a/lisp/pcmpl-unix.el b/lisp/pcmpl-unix.el
index dc0d729849..27584c27a7 100644
--- a/lisp/pcmpl-unix.el
+++ b/lisp/pcmpl-unix.el
@@ -83,7 +83,7 @@ pcomplete/rm
 ;;;###autoload
 (defun pcomplete/xargs ()
   "Completion for `xargs'."
-  (pcomplete-here (funcall pcomplete-command-completion-function))
+  (funcall pcomplete-command-completion-function)
   (funcall (or (pcomplete-find-completion-function (pcomplete-arg 1))
 	       pcomplete-default-completion-function)))
 
diff --git a/lisp/shell.el b/lisp/shell.el
index e574aac99d..d2c41a9690 100644
--- a/lisp/shell.el
+++ b/lisp/shell.el
@@ -461,9 +461,12 @@ shell-command-completion-function
 This is the value of `pcomplete-command-completion-function' for
 Shell buffers.  It implements `shell-completion-execonly' for
 `pcomplete' completion."
-  (pcomplete-here (pcomplete-entries nil
-				     (if shell-completion-execonly
-					 'file-executable-p))))
+  (if (pcomplete-match "/")
+      (pcomplete-here (pcomplete-entries nil
+					 (if shell-completion-execonly
+					     'file-executable-p)))
+    (pcomplete-here
+     (nth 2 (shell--command-completion-data)))))
 
 (defun shell-completion-vars ()
   "Setup completion vars for `shell-mode' and `read-shell-command'."